package první;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

class Okno extends JFrame
{
    private static final int šířka = 640;
    private static final int výška = 480;
    public Okno(String titulek)
    {
        super(titulek);
        //setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE);
        setSize(šířka, výška);
        Dimension rozměry = Toolkit.getDefaultToolkit().getScreenSize();
        setLocation(rozměry.width/2 - šířka/2, rozměry.height/2-výška/2);
        try
        {
            //UIManager.setLookAndFeel("javax.swing.plaf.metal.MetalLookAndFeel");
            UIManager.setLookAndFeel("javax.swing.plaf.nimbus.NimbusLookAndFeel");
        }
        catch(Exception e)
        {
            System.out.println(e.getMessage());
        }
//        setLayout(new BorderLayout(10, 5));
//        add(t1, BorderLayout.NORTH);
//        add(t5, BorderLayout.CENTER);
//        add(t2, BorderLayout.EAST);
//        add(t3, BorderLayout.WEST);
//        add(t4, BorderLayout.SOUTH);
//        setLayout(new FlowLayout());
//        add(t1);
//        add(t2);
//        add(t3);
//        add(t4);
//        add(t5);
        setLayout(null);
        tlačítkoKonec.setSize(200, 30);
        tlačítkoKonec.setLocation(50, 50);
        add(tlačítkoKonec);
        tlačítkoKonec.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                var pom = new ObsluhaKonce();
                pom.windowClosing(null);
            }});
        setJMenuBar(pruhNabídky);
        pruhNabídky.add(nabídkaÚloha);
        pruhNabídky.add(nabídkaNápověda);
        nabídkaÚloha.add(nabídkaNová);
        nabídkaÚloha.add(nabídkaNakreslit);
        nabídkaÚloha.addSeparator();
        nabídkaÚloha.add(nabídkaUpravit);
        nabídkaNápověda.add(nabídkaOProgramu);
        nabídkaNová.setIcon(new ImageIcon(ikony.Ikony.class.getResource("menu_new.png")));
        nabídkaOProgramu.addActionListener((e)->{JOptionPane.showMessageDialog(this, "Program na řešení úlohy N dam\n(c) Piškvorky software 2024", "O programu", 0);});
        addWindowListener(new ObsluhaKonce());
        nabídkaUpravit.addActionListener(this::obsluhaUpravit);
        nabídkaNakreslit.addActionListener(this::obsluhaKreslení);
    }
    
    private void obsluhaUpravit(ActionEvent e)
    {
        dialogNastavení.setVisible(true);
    }
    
    class ObsluhaKonce extends WindowAdapter
    {
        @Override public void windowClosing(WindowEvent e)
            {
                int odpověď = JOptionPane.showConfirmDialog(rootPane, "Opravdu chceš skončit?", "Dotaz", JOptionPane.OK_CANCEL_OPTION);
                if(odpověď == JOptionPane.OK_OPTION)
                {
                    System.exit(0);
                }
            }
    }
    
    @Override public void paint(Graphics g)
    {
        super.paint(g);
        if(nakresleno)
        {
            g.drawLine(0, 0, 100, 100);
        }
    }
    
    private void obsluhaKreslení(ActionEvent e)
    {
        nakresleno = true;
        repaint();
    }
    
    
    private JButton tlačítkoKonec = new JButton("Konec");
    private JButton t2 = new JButton("2");
    private JButton t3 = new JButton("3");
    private JButton t4 = new JButton("5");
    private JButton t5 = new JButton("5");
    
    private JMenuBar pruhNabídky = new JMenuBar();
    private JMenu nabídkaÚloha = new JMenu("Úloha");
    private JMenu nabídkaNápověda = new JMenu("Nápověda");
    private JMenuItem nabídkaNová = new JMenuItem("Nová");
    private JMenuItem nabídkaOProgramu = new JMenuItem("O programu...");
    private JMenuItem nabídkaUpravit = new JMenuItem("Upravit nastavení...");
    private JMenuItem nabídkaNakreslit = new JMenuItem("Nakresli");
    
    private DialogNastavení dialogNastavení = new DialogNastavení(this);
    private boolean nakresleno = false;
}


class DialogNastavení extends JDialog
{
    private JSpinner volič = new JSpinner();
    public DialogNastavení(JFrame vlastník)
    {
        super(vlastník, true);
        this.setSize(300, 200);
        this.setTitle("Nastavení");
        this.setDefaultCloseOperation(JFrame.HIDE_ON_CLOSE);
        this.setLayout(null);
        tlačítkoOK.setSize(80, 20);
        tlačítkoOK.setLocation(100, 70);
        add(tlačítkoOK);
    }
    
    private JButton tlačítkoOK = new JButton("OK");
    private JButton tlačítkoStorno = new JButton("Storno");
}

public class Program 
{
    public static void main(String[] args) 
    {
//        SwingUtilities.invokeLater(()->
//        {
//            Okno okno = new Okno("První okno");
//            okno.setVisible(true);
//        }
//        );
        EventQueue.invokeLater(()->
        {
            Okno okno = new Okno("První okno");
            okno.setVisible(true);
        }
        );
    }
    
}
