package úlohandam;

import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import javax.swing.*;

public class DialogNastavení extends JDialog
{
    public DialogNastavení(JFrame vlastník, Point pozice)
    {
        super(vlastník, "Volby", true);
        setDefaultCloseOperation(JDialog.HIDE_ON_CLOSE);
        inicializace(pozice);
    }
    
    private void inicializace(Point pozice)
    {
        this.setLayout(null);
        this.setResizable(false);
        this.setSize(new Dimension(448, 200));
        this.setLocation(pozice);
        vložKomponentu(nápis, 100, 20, 20, 30);
        vložKomponentu(volič, 50, 30, 90, 30);
        vložKomponentu(tlačítkoOK, 100, 30, 150, 100);
        vložKomponentu(tlačítkoStorno, 100, 30, 270, 100);
        tlačítkoOK.addActionListener(this::obsluhaOK);
        tlačítkoStorno.addActionListener(this::obsluhaStorno);
        addWindowListener(new WindowAdapter(){
           @Override public void windowActivated(WindowEvent e)
           {
               volič.setValue(Nastavení.getPočetDam());
           }
        });
    }
    
    private void vložKomponentu(Component komponenta, int šířka, int výška, int x, int y)
    {
        komponenta.setSize(šířka, výška);
        komponenta.setLocation(x, y);
        add(komponenta);
    }
    
    private void obsluhaOK(ActionEvent e)
    {
        Nastavení.setPočetDam((int)volič.getValue());
        setVisible(false);
    }
    
    private void obsluhaStorno(ActionEvent e)
    {
        setVisible(false);
    }
    
    private final JSpinner volič = new JSpinner(new SpinnerNumberModel(8, 4, 30, 1));
    private final JButton tlačítkoOK = new JButton("OK");
    private final JButton tlačítkoStorno = new JButton("Storno");
    private final JLabel nápis = new JLabel("Počet dam: ");
}
